unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Edit4: TEdit;
    Label4: TLabel;
    PaintBox1: TPaintBox;
    Label5: TLabel;
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure selcolor(sender : TObject; color : LongInt);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses davColorBox;

const mypalette : array[0..7] of byte = ($ff,$d0,$80,$60,$40,$a0,$b0,$c0);

var kleur: longInt = $808080;
    box  : TdavcolorBox;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with paintbox1 do
  with canvas do
   begin
    pen.width := 1;
    pen.color := $0;
    brush.color := kleur;
    brush.style := bsSolid;
    fillrect(rect(0,0,width,height));
    brush.style := bsclear;
    rectangle(0,0,width,height);
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 box.invalidate;
end;

procedure TForm1.formcreate(sender : TObject);
begin
 box := TdavcolorBox.create(self);
  with box do
   begin
    parent := self;
    left := 10;
    top := 10;
    onSelect := selcolor;
   end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 box.free;
 box := nil;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var dir : TColorBoxDir;
begin
 if sender = speedbutton1 then dir := cbHor else dir := cbvert;
 box.direction := dir;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var s : string;
    val : longInt;
begin
 if key = #13 then
  begin
   if activecontrol = edit1 then s := edit1.text
   else if activecontrol = edit2 then s := edit2.text
   else if activecontrol = edit3 then s := edit3.Text
   else if activecontrol = edit4 then s := edit4.text
  end
 else exit;
//--
 try
  val := strtoint(s);
 except
  exit;
 end;
//--
 with box do
  if activecontrol = edit1 then border := val
  else if activecontrol = edit2 then borderlight := val
  else if activecontrol = edit3 then borderdark := val
  else if activecontrol = edit4 then Csquare := val;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 with box do
  if sender = speedbutton3 then colordepth := cb8
  else if sender = speedbutton4 then colordepth := cb64
  else if sender = speedbutton5 then colordepth := cb512;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 box.visible := checkbox1.checked; 
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 box.enabled := checkbox2.checked;
end;

procedure Tform1.selcolor(sender : TObject; color : LongInt);
begin
 kleur := color;
 paintbox1.invalidate;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
 if checkbox3.checked then box.palette := @mypalette
 else box.palette := nil;
end;

end.
